/// <reference types="node" />
export interface ILocalizedMessage {
    [key: string]: string;
}
export interface IErrorOptions {
    name?: string;
    code?: number;
    messages?: ILocalizedMessage;
    prefix?: string;
    alias?: string;
    [key: string]: any;
}
export declare class LocalizedError {
    protected options: IErrorOptions;
    constructor(options: IErrorOptions);
    get(): {
        new (locale?: string | undefined): {
            [key: string]: any;
            toJSON(): {
                code: any;
                message: string;
                name: string;
            };
            getMessage(locale: string): string;
            name: string;
            message: string;
            stack?: string | undefined;
        };
        captureStackTrace(targetObject: Object, constructorOpt?: Function | undefined): void;
        prepareStackTrace?: ((err: Error, stackTraces: NodeJS.CallSite[]) => any) | undefined;
        stackTraceLimit: number;
    };
}
